=== modified file 'src/com/goldencode/p2j/main/StandardServer.java'
--- old/src/com/goldencode/p2j/main/StandardServer.java	2022-05-16 07:25:30 +0000
+++ new/src/com/goldencode/p2j/main/StandardServer.java	2022-09-06 18:22:04 +0000
@@ -196,6 +196,13 @@
 **     CA  20220405          Added authentication and authorization for web requests.  When this is enabled, 
 **                           the target API call will be executed under the authenticated FWD context, and not 
 **                           the agent's context.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
+**     CA  20220906          Moved the interactive client cleaner to LogicalTerminal.registerCleaner().
 */
 
 /*
@@ -1166,11 +1173,7 @@
    /**
     * Register default services:
     * <ol>
-    * <li> {@link SharedVariableManager} </li>
-    * <li> {@link UnnamedStreams} </li>
-    * <li> {@link LogicalTerminal} </li>
     * <li> {@link Persistence} </li>
-    * <li> {@link AccumulatorManager} </li>
     * <li> {@link WebServer} </li>
     * <li> custom account extension plugin </li>
     * </ol>
@@ -1237,33 +1240,6 @@
          @Override
          public void initialize()
          {
-            SharedVariableManager.initialize();
-         }
-      });
-
-      serverHooks.add(new AbstractInitTermListener()
-      {
-         @Override
-         public void initialize()
-         {
-            UnnamedStreams.initialize();
-         }
-      });
-      
-      serverHooks.add(new AbstractInitTermListener()
-      {
-         @Override
-         public void initialize()
-         {
-            LogicalTerminal.initialize();
-         }
-      });
-      
-      serverHooks.add(new AbstractInitTermListener()
-      {
-         @Override
-         public void initialize()
-         {
             ServerKeyStore.initialize();
          }
       });
@@ -1309,16 +1285,7 @@
             }
          }
       });
-      
-      serverHooks.add(new AbstractInitTermListener()
-      {
-         @Override
-         public void initialize()
-         {
-            AccumulatorManager.initialize();
-         }
-      });
-      
+
       // register controller for method execution tracing
       serverHooks.add(new AbstractInitTermListener()
       {
@@ -1712,6 +1679,9 @@
                                    false,
                                    false);
       
+      // make sure that the global block gets a special notification - but only for non-appserver sessions.
+      LogicalTerminal.registerCleaner();
+      
       Object result = null;
       try
       {

=== modified file 'src/com/goldencode/p2j/persist/AdaptiveQuery.java'
--- old/src/com/goldencode/p2j/persist/AdaptiveQuery.java	2022-07-25 23:00:26 +0000
+++ new/src/com/goldencode/p2j/persist/AdaptiveQuery.java	2022-09-06 18:22:04 +0000
@@ -329,6 +329,12 @@
 **                           DmoMeta to avoid duplicating their collection and storage.
 **     OM  20220726          Added recordAlreadyFound flag for block next/prev iterations on unique
 **                           find-by-rowid queries.
+**     CA  20220901          Refactored scope notification support: ScopeableFactory was removed, and the 
+**                           registration is now specific to each type of scopeable.  For each case, the block
+**                           will be registered for scope support (for that particular scopeable) only when
+**                           the scopeable is 'active' (i.e. unnamed streams or accumulators are used).  This
+**                           allows a lazy registration of scopeables, to avoid the unnecessary overhead of
+**                           processing all the scopeables for each and every block.
 */
 
 /*
@@ -1075,7 +1081,7 @@
    {
       closed = false;
       
-      int scope = TransactionManager.findNearestExternal();
+      int scope = BufferManager.get().findNearestExternal();
       RecordBuffer[] buffers = getRecordBuffers();
       
       for (RecordBuffer buffer : buffers)

